import { system, world, BlockTypes } from "@minecraft/server";

const LEAF_TYPES = [
    "minecraft:oak_leaves",
    "minecraft:spruce_leaves",
    "minecraft:birch_leaves",
    "minecraft:jungle_leaves",
    "minecraft:acacia_leaves",
    "minecraft:dark_oak_leaves",
    "minecraft:mangrove_leaves",
    "minecraft:cherry_leaves",
];

world.afterEvents.blockBreak.subscribe((event) => {
    let { block, dimension } = event;
    
    // Check if the broken block is a log
    if (block.typeId.endsWith("_log") || block.typeId.endsWith("_wood")) {
        let { x, y, z } = block.location;

        // Scan for nearby leaves and remove them
        for (let dx = -3; dx <= 3; dx++) {
            for (let dy = -3; dy <= 3; dy++) {
                for (let dz = -3; dz <= 3; dz++) {
                    let leafBlock = dimension.getBlock({ x: x + dx, y: y + dy, z: z + dz });
                    if (leafBlock && LEAF_TYPES.includes(leafBlock.typeId)) {
                        dimension.getBlock({ x: x + dx, y: y + dy, z: z + dz }).setType(BlockTypes.get("minecraft:air"));
                    }
                }
            }
        }
    }
});